library(s2dverification)
sdates <- '19790101'
YourPath <- "/esarchive/scratch/nperez/git/Flor/s2dverification_tests/"
obs <- list(name = 'observation', 
             path = paste0(YourPath, 
                    "vspeed_Aday_ERAInterim_$YEAR$$MONTH$$DAY$_197912.nc"))
data <- Load('u10', exp = NULL, obs = list(obs), sdates = sdates,
             output = 'lonlat', storefreq = 'daily',
             dimnames = list(lat = 'latitude', lon = 'longitude', ltime = 'time'))

# -------------------------------
> dim(data$obs)
dataset  member   sdate   ftime     lat     lon 
      1       1       1   14897      41      67 
> head(data$obs)
[1]  5.3022  8.5443  7.1159 12.5360 20.3170 17.9770

library(ncdf4)
ncfile <- paste0(YourPath,
                 "vspeed_Aday_ERAInterim_19790101_197912.nc")
a <- nc_open(ncfile)
var <- ncvar_get(a, 'u10')

library(startR)
startRdata <- Start(dat = ncfile, var = 'u10',
              latitude = 'all',
              longitude = 'all',
              time = 'all' 
              return_vars = list(latitude = 'dat', longitude = 'dat', time = 'dat'),
              retrieve = TRUE)

